<template>
  <div>
    <!--查询区域-->
    <div class="jeecg-basic-table-form-container">
      <a-form @keyup.enter.native="searchQuery" :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
        <a-row :gutter="24">
          <a-col :lg="8">
            <a-form-item label="微信公众号唯一id">
              <JSelectWxSysSet v-model:value="queryParam.msgBiz" ></JSelectWxSysSet>
            </a-form-item>
          </a-col>
          <template v-if="toggleSearchStatus">
            <a-col :lg="8">
              <a-form-item label="添加时间">
                <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择开始时间" v-model:value="queryParam.publishAt_begin" class="query-group-cust" />
                <span class="query-group-split-cust">~</span>
                <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择结束时间" v-model:value="queryParam.publishAt_end" class="query-group-cust" />
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="标题">
                <a-input placeholder="请输入标题" v-model:value="queryParam.title"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="更新时间">
                <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择开始时间" v-model:value="queryParam.updateAt_begin" class="query-group-cust" />
                <span class="query-group-split-cust">~</span>
                <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择结束时间" v-model:value="queryParam.updateAt_end" class="query-group-cust" />
              </a-form-item>
            </a-col>

            <a-col :lg="8">
              <a-form-item label="更新数量时间">
                <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择开始时间" v-model:value="queryParam.updateNumAt_begin" class="query-group-cust" />
                <span class="query-group-split-cust">~</span>
                <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择结束时间" v-model:value="queryParam.updateNumAt_end" class="query-group-cust" />
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="是否忽略">
                <j-dict-select-tag placeholder="请选择是否忽略" v-model:value="queryParam.isIgnore" dictCode="verify_status"/>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核时间">
                <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择开始时间" v-model:value="queryParam.checkTime_begin" class="query-group-cust" />
                <span class="query-group-split-cust">~</span>
                <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择结束时间" v-model:value="queryParam.checkTime_end" class="query-group-cust" />
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核状态">
                <j-dict-select-tag placeholder="请选择复核状态" v-model:value="queryParam.checkState" dictCode="review_status"/>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核校对错误个数">
                <a-input placeholder="请输入复核校对错误个数" v-model:value="queryParam.checkErrorCount"></a-input>
              </a-form-item>
            </a-col>
          </template>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <span style="float: left; overflow: hidden" class="table-page-search-submitButtons">
              <a-col :lg="6">
                <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset" style="margin-left: 8px">重置</a-button>
                <a @click="toggleSearchStatus = !toggleSearchStatus" style="margin-left: 8px">
                  {{ toggleSearchStatus ? '收起' : '展开' }}
                  <Icon :icon="toggleSearchStatus ? 'ant-design:up-outlined' : 'ant-design:down-outlined'" />
                </a>
              </a-col>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
        <a-button  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
        <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
        <a-button type="primary" @click="handleCrawling" preIcon="ant-design:plus-outlined"> 抓取数据</a-button>
        <a-button type="primary" @click="onHandleCheckWx" preIcon="ant-design:plus-outlined"> 复核数据</a-button>
        <a-dropdown v-if="selectedRowKeys.length > 0">
          <template #overlay>
            <a-menu>
              <a-menu-item key="1" @click="batchHandleDelete">
                <Icon icon="ant-design:delete-outlined"></Icon>
                删除
              </a-menu-item>
              <a-menu-item key="2" @click="batchWhetherIgnoreHandle">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量忽略
              </a-menu-item>
              <a-menu-item key="2" @click="batchWhetherIgnoreHandleDelete">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量取消忽略
              </a-menu-item>
              <a-menu-item key="4" @click="batchModifyTrue">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量已修改
              </a-menu-item>
              <a-menu-item key="5" @click="batchModifyFalse">
                <Icon icon="ant-design:close-circle-outlined"></Icon>
                批量取消已修改
              </a-menu-item>
              <a-menu-item key="5" @click="IgnoreHandleDelete">
                <Icon icon="ant-design:close-circle-outlined"></Icon>
                批量设置单词不扫描
              </a-menu-item>
              <a-menu-item key="5" @click="batchIgnoreAllHandleDelete">
                <Icon icon="ant-design:close-circle-outlined"></Icon>
                批量取消设置单词不扫描
              </a-menu-item>
            </a-menu>
          </template>
          <a-button>批量操作
            <Icon icon="mdi:chevron-down"></Icon>
          </a-button>
        </a-dropdown>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction  :dropDownActions="getDropDownAction(record)"/>
      </template>

      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
        <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
        {{ getAreaTextByCode(text) }}
      </template>
      <!--字段回显插槽-->
      <template #customColumnErr="{text}">
        <div v-html="text"></div>
      </template>
      <!--字段回显插槽-->
      <template #aurl="{text}">
        <a :href="text" :title="text" target="_blank" >{{ subString(text)  }}</a>
      </template>
      <template #customColumn="{ text }" style="width: 50%">
        <a-popover title="详细内容" trigger="hover">
          <template #title>
            <div v-html="text"></div>
          </template>
          <template #content>
            <div v-html="text"></div>
          </template>
          <div style="width: 100%">
            <a-collapse :bordered="false" >
              <a-collapse-panel key="1" header="点击查看详情">
                <div v-html="text"></div>
              </a-collapse-panel>
            </a-collapse>
          </div>
        </a-popover>
      </template>
      <template #fileSlot="{text}">
        <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
        <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <WechatPostsWordModal ref="registerModal" @success="handleSuccess"></WechatPostsWordModal>


    <a-modal
      v-model:visible="visible"
      :title="'是否已经修改：'+title"
      ok-text="已经修改"
      cancel-text="取消"
      @ok="hideModalSelectOk"
      @cancel="closeModalSelectCancel"
    >
      <div style="text-align: center">
        <div style="padding: 50px;text-align: left">
          <a target="_blank" :href="source">{{ source }}</a>
          <a target="_blank" :href="source">{{ hideModalSelectCancelId }}</a>
        </div>
        <div style="padding-bottom: 50px;padding-left: 50px;padding-right: 50px" v-html="sensitiveList"></div>
      </div>
      <template #footer>
        <a-button @click="closeModalSelectCancel">关闭</a-button>
        <a-button type="primary" @click="hideModalSelectCancel">未修改</a-button>
        <a-button type="primary" @click="hideModalSelectOk">已经修改</a-button>
      </template>

    </a-modal>

    <a-modal
      v-model:visible="visibleisWhetherToIgnore"
      :title="'是否忽略：'+title"
      ok-text="已经忽略"
      cancel-text="取消忽略"
      @ok="whetherToIgnoreSelectOk"
      @cancel="closewhetherToIgnore"
    >
      <div style="text-align: center">
        <div style="padding: 50px;text-align: left">
          <a target="_blank" :href="source">{{ source }}</a>
          <a target="_blank" :href="source">{{ hideModalSelectCancelId }}</a>
        </div>
        <div style="padding-bottom: 50px;padding-left: 50px;padding-right: 50px" v-html="sensitiveList"></div>
      </div>
      <template #footer>
        <a-button @click="closewhetherToIgnore">关闭</a-button>
        <a-button type="primary" @click="closewhetherToIgnoreSelectCancel">设置不忽略</a-button>
        <a-button type="primary" @click="whetherToIgnoreSelectOk">设置忽略</a-button>
      </template>
    </a-modal>
    <a-modal
      v-model:visible="visibleIgnore"
      :title="'是否单词不扫描：'+title"
      ok-text="保存"
      cancel-text="取消"
      width="800px"
      @ok="hideModalSelect"
    >
      <div v-if="visibleIgnore" style="text-align: left;width: 90%;margin: auto">
        <div style="padding: 20px">
          <a target="_blank" :href="source">{{source}}</a>
        </div>
        <div style="padding: 20px">
          <a-checkbox
            v-model:checked="state.checkAll"
            :indeterminate="state.indeterminate"
            @change="onCheckAllChange"
          >
            全选
          </a-checkbox>
          <a-divider />
          <a-checkbox-group v-model:value="state.checkedList" style="width: 100%;text-align: left">
            <a-row>
              <a-col :span="12">
                <a-row>
                  <a-col :span="24" v-for="item in plainOptions">
                    <a-checkbox :value="item">{{item}}</a-checkbox>
                    <div style="height: 5px"></div>
                  </a-col>
                </a-row>
              </a-col>
              <a-col :span="12">
                <a-row>
                  <a-col :span="24" v-for="item in plainOptionsHtml">
                    <div v-html="item"></div>
                    <div style="height: 5px"></div>
                  </a-col>
                </a-row>
              </a-col>
            </a-row>
          </a-checkbox-group>
        </div>
      </div>
    </a-modal>


  </div>
</template>

<script lang="ts" name="wechatpostsword-wechatPostsWord" setup>
import { useRouter } from 'vue-router';
import {ref, reactive, onBeforeMount} from 'vue';
import { BasicTable } from '/@/components/Table';
import {  useTable } from '/@/components/Table';
import {  TableAction } from '/@/components/Table';
import { useListPage } from '/@/hooks/system/useListPage';
import { columns } from './WechatPostsWord.data';
import { list, deleteOne, batchDelete, getImportUrl, getExportUrl,
  ignoreAllCancellBatchDelete,
  ignoreBatchDelete,
  ignoreWhetherBatch, ignoreWhetherBatchDelete, ModifyFalseBatchDelete, ModifyTrueBatchDelete
} from './WechatPostsWord.api';
import { downloadFile } from '/@/utils/common/renderUtils';
import WechatPostsWordModal from './components/WechatPostsWordModal.vue'
import JDictSelectTag from '/@/components/Form/src/jeecg/components/JDictSelectTag.vue';
import { useAppStore } from '/@/store/modules/app';
import JSelectWxSysSet from '/@/components/Form/src/jeecg/components/JSelectWxSysSet.vue';
const queryParam = ref<any>({});
const toggleSearchStatus = ref<boolean>(false);
const registerModal = ref();

import {defHttp} from "/@/utils/http/axios";

const appStore = useAppStore();

const visible = ref<boolean>(false);
const visibleIgnore = ref<boolean>(false);
const visibleisWhetherToIgnore = ref<boolean>(false);

const title = ref();
const source = ref();
const sensitiveList = ref();
const wechatId = ref();
const sensitiveArrayList = ref([]);
const hideModalSelectCancelId = ref<number>();
const plainOptions = [''];
const plainOptionsHtml = [''];


const router = useRouter();

//注册table数据
const { prefixCls, tableContext, onExportXls, onImportXls,onHandleCheckWx} = useListPage({
  tableProps: {
    title: '微信公众号文章错敏词',
    api: list,
    columns,
    canResize:false,
    useSearchForm: false,
    actionColumn: {
      width: 120,
      fixed: 'right',
    },
    beforeFetch: (params) => {
      return Object.assign(params, queryParam.value);
    },
  },
  exportConfig: {
    name: "微信公众号文章错敏词",
    url: getExportUrl,
  },
  importConfig: {
    url: getImportUrl,
    success: handleSuccess
  },
});
const [registerTable, { reload, collapseAll, updateTableDataRecord, findTableDataRecord, getDataSource }, { rowSelection, selectedRowKeys }] = tableContext;
const labelCol = reactive({
  xs: { span: 24 },
  sm: { span: 7 },
});
const wrapperCol = reactive({
  xs: { span: 24 },
  sm: { span: 16 },
});
function subString(str:string){
  if(str.length > 35){
    str = str.substring(0,35) + "....."
  }
  return str
}

function handleCrawling() {
  defHttp.get({
    url:'/wechatpostsword/wechatPostsWord/listCrawling',
    timeout:100000,
  }).then((res)=>{
    reload()
  })
}
/**
 * 新增事件
 */
function handleAdd() {
  registerModal.value.disableSubmit = false;
  registerModal.value.add();
}

/**
 * 编辑事件
 */
function handleEdit(record: Recordable) {
  registerModal.value.disableSubmit = false;
  registerModal.value.edit(record);
}

/**
 * 详情
 */
function handleDetail(record: Recordable) {
  registerModal.value.disableSubmit = true;
  registerModal.value.edit(record);
}

/**
 * 删除事件
 */
async function handleDelete(record) {
  await deleteOne({ id: record.id }, handleSuccess);
}

/**
 * 批量删除事件
 */
async function batchHandleDelete() {
  await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
}

async function batchIgnoreHandleDelete() {
  await ignoreBatchDelete({ ids: selectedRowKeys.value }, handleSuccess);
}

async function batchWhetherIgnoreHandle() {
  await ignoreWhetherBatch({ ids: selectedRowKeys.value }, handleSuccess);
}

async function batchWhetherIgnoreHandleDelete() {
  await ignoreWhetherBatchDelete({ ids: selectedRowKeys.value }, handleSuccess);
}
async function IgnoreHandleDelete() {
  await ignoreBatchDelete({ ids: selectedRowKeys.value }, handleSuccess);
}

async function batchIgnoreAllHandleDelete() {
  await ignoreAllCancellBatchDelete({ ids: selectedRowKeys.value }, handleSuccess);
}

async function batchModifyTrue() {
  await ModifyTrueBatchDelete({ ids: selectedRowKeys.value }, handleSuccess);
}

async function batchModifyFalse() {
  await ModifyFalseBatchDelete({ ids: selectedRowKeys.value }, handleSuccess);
}


/**
 * 成功回调
 */
function handleSuccess() {
  (selectedRowKeys.value = []) && reload();
}

/**
 * 操作栏
 */
function getTableAction(record) {
  return [
    {
      label: '编辑',
      onClick: handleEdit.bind(null, record),
    },
  ];
}

/**
 * 实时定位
 */
function realTimeEdit(record: Recordable) {
  const url = router.resolve({
    path: '/MyIndexWx/'+record.id
  });
  window.open(url.href);
}
/**
 * 实时定位
 */
function oldTimeEdit(record: Recordable) {
  const url = router.resolve({
    path: '/MyIndexOldWx/'+record.id
  });
  window.open(url.href);
}


/**
 * 详情
 */
function handleModify(record: Recordable) {
  showModal(record);
}


/**
 * 详情
 */
function handleIgnore(record: Recordable) {
  showModalIgnore(record);
}

function handlewhetherToIgnore(record: Recordable) {
  showModalWhetherToIgnore(record);
}

const showModal = (record: Recordable) => {
  title.value = record.title;
  source.value = record.link;
  sensitiveList.value = record.sensitiveList;
  hideModalSelectCancelId.value = record.id
  visible.value = true;
};
const showModalWhetherToIgnore = (record: Recordable) => {
  title.value = record.title;
  source.value = record.link;
  sensitiveList.value = record.sensitiveList;
  hideModalSelectCancelId.value = record.id
  visibleisWhetherToIgnore.value = true;
};
const state = reactive({
  indeterminate: true,
  checkAll: false,
  checkedList: [''],
});
const showModalIgnore = (record: Recordable) => {
  plainOptions.length = 0
  plainOptionsHtml.length = 0
  state.checkedList.length = 0
  wechatId.value = null
  wechatId.value = record.id
  defHttp.get({
    url:'/wechatpostsword/wechatPostsWord/queryByIdErrorList?id='+record.id,
  }).then((res)=>{
    title.value = record.title;
    source.value = record.link;
    for (let i = 0; i < res.length; i++) {
      plainOptions[i] = res[i].wordName
      if(res[i].flag == true || res[i].flag == 'true'){
        state.checkedList[i] = res[i].wordName
      }
      plainOptionsHtml[i] = res[i].wordValue
    }
    visibleIgnore.value = true;
  })
};

/**
 * 下拉操作栏
 */
function getDropDownAction(record) {
  return [
    {
      label: '详情',
      onClick: handleDetail.bind(null, record),
    },
    {
      label: '定位',
      onClick: realTimeEdit.bind(null, record),
    },
    {
      label: '是否已经修改',
      onClick: handleModify.bind(null, record),
    },
    {
      label: '是否忽略',
      onClick: handlewhetherToIgnore.bind(null, record),
    },
    {
      label: '是否设置单词不扫描',
      onClick: handleIgnore.bind(null, record),
    },
    {
      label: '删除',
      popConfirm: {
        title: '是否确认删除',
        confirm: handleDelete.bind(null, record),
      }
    }
  ]
}

/**
 * 查询
 */
function searchQuery() {
  reload();
}

/**
 * 重置
 */
function searchReset() {
  queryParam.value = {};
  selectedRowKeys.value = [];
  //刷新数据
  reload();
}

const hideModalSelectOk = () => {
  if(hideModalSelectCancelId.value != null){
    defHttp.get({
      url:'/wechatpostsword/wechatPostsWord/queryByIdModifyTrue?id='+hideModalSelectCancelId.value
    }).then((res)=>{
      reload();
    })
  }
  visible.value = false;
};

const closeModalSelectCancel = () => {
  visible.value = false;
};
const whetherToIgnoreSelectOk = () => {
  if(hideModalSelectCancelId.value != null){
    defHttp.get({
      url:'/wechatpostsword/wechatPostsWord/queryWhetherToIgnore?id='+hideModalSelectCancelId.value
    }).then((res)=>{
      reload();
    })
  }
  visibleisWhetherToIgnore.value = false;
};
const closewhetherToIgnore = () => {
  visibleisWhetherToIgnore.value = false;
};


const hideModalSelectCancel = () => {
  if(hideModalSelectCancelId.value != null){
    defHttp.get({
      url:'/wechatpostsword/wechatPostsWord/queryByIdModifyFalse?id='+hideModalSelectCancelId.value
    }).then((res)=>{
      reload();
    })
  }
  visible.value = false;
};
const closewhetherToIgnoreSelectCancel = () => {
  if(hideModalSelectCancelId.value != null){
    defHttp.get({
      url:'/wechatpostsword/wechatPostsWord/queryWhetherToIgnoreCancel?id='+hideModalSelectCancelId.value
    }).then((res)=>{
      reload();
    })
  }
  visibleisWhetherToIgnore.value = false;
};

const hideModalSelect = () => {
  let params = Object.assign({ checkedList: state.checkedList },{ plainOptions: plainOptions },{ weiboId: wechatId.value });
  defHttp.post({ url: '/wechatpostsword/wechatPostsWord/ignore', params }, { isTransformResponse: false }).then((res) => {
  });
  visibleIgnore.value = false;
};

const onCheckAllChange = (e: any) => {
  Object.assign(state, {
    checkedList: e.target.checked ? plainOptions : [],
    indeterminate: false,
  });
};


onBeforeMount(()=>{
  //appStore.setMessageParams("aaaaaaaaaaaaaaaaa");
  queryParam.value.isIgnore = "2"
  queryParam.value.modifyState = "1"
  var mainSite = localStorage.getItem("main_site");
  if(mainSite != null){
    try {
      var objMainSite = JSON.parse(mainSite);
      if(objMainSite.mainSiteUrl != null && objMainSite.mainSiteUrl != ""){
        queryParam.value.mainUrl = "*"+objMainSite.mainSiteUrl+"*"
      }
    }catch (err){
      queryParam.value.mainUrl = null
    }
  }else {
    queryParam.value.mainUrl = null
  }
  localStorage.removeItem("query_param");
  localStorage.setItem("query_param",JSON.stringify(queryParam));
})
</script>

<style lang="less" scoped>
.jeecg-basic-table-form-container {
  .table-page-search-submitButtons {
    display: block;
    margin-bottom: 24px;
    white-space: nowrap;
  }
  .query-group-cust{
    width: calc(50% - 15px);
    min-width: 100px !important;
  }
  .query-group-split-cust{
    width: 30px;
    display: inline-block;
    text-align: center
  }
}
</style>
